/********************************************************************-*-c-*-*\
*               *  Class examples for Advanced Porgramming                   *
*    #####      *  (!) Giovanni Squillero <giovanni.squillero@polito.it>     *
*   ######      *                                                            *
*   ###   \     *  Copying and distribution of this file, with or without    *
*    ##G  c\    *  modification, are permitted in any medium without royalty *
*    #     _\   *  provided this notice is preserved.                        *
*    |   _/     *  This file is offered as-is, without any warranty.         *
*    |  _/      *                                                            *
*               *  See: http://staff.polito.it/giovanni.squillero/dida.php   *
\****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "queue.h"
#include "utils.h"

QUEUE *QueueInit(int dim)
{
    QUEUE *Q;

    Q = Malloc(sizeof (QUEUE));
    Q->dim = dim;
    Q->head = 0;
    Q->tail = 0;
    Q->vett = Malloc(Q->dim * sizeof (int));
    return Q;
}


void Enqueue(QUEUE *Q, int val)
{
    Q->vett[Q->head] = val;
    Q->head = (Q->head+1)%Q->dim;
}


int Dequeue(QUEUE *Q)
{
    int v;
    v = Q->vett[Q->tail];
    Q->tail = (Q->tail+1)%Q->dim;
    return v;
}


int QueueFull(QUEUE *Q)
{
    return Q->tail == (Q->head+1)%Q->dim;
}


int QueueEmpty(QUEUE *Q)
{
    return Q->head == Q->tail;
}
